#! /bin/sh

# Bootstrap this package from CVS.

# Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

# Written by Paul Eggert.

package=bison

# Translation Project URL, for the registry of all projects.
TP_URL='http://www.iro.umontreal.ca/translation/registry.cgi?domain='

# Ensure file names are sorted consistently across platforms.
# Also, ensure diagnostics are in English, e.g., "wget --help" below.
LC_ALL=C
export LC_ALL

# Parse options.

for option
do
  case $option in
  --help)
    echo "$0: usage: $0 [--gnulib-srcdir=DIR] [--cvs-user=USERNAME] [--skip-po]"
    exit;;
  --gnulib-srcdir=*)
    GNULIB_SRCDIR=`expr "$option" : '--gnulib-srcdir=\(.*\)'`;;
  --cvs-user=*)
    CVS_USER=`expr "$option" : '--cvs-user=\(.*\)'`;;
  --skip-po)
    SKIP_PO=t;;
  *)
    echo >&2 "$0: $option: unknown option"
    exit 1;;
  esac
done

echo "$0: Bootstrapping CVS $package..."

cleanup_gnulib() {
  status=$?
  rm -fr gnulib
  exit $status
}

# Get gnulib files.

case ${GNULIB_SRCDIR--} in
-)
  if [ ! -d gnulib ]; then
    echo "$0: getting gnulib files..."

    case ${CVS_AUTH-pserver} in
    pserver)
      CVS_PREFIX=':pserver:anonymous@';;
    ssh)
      CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
    *)
      echo "$0: $CVS_AUTH: Unknown CVS access method" >&2
      exit 1;;
    esac

    case $CVS_RSH in
    '') export CVS_RSH=ssh;;
    esac

    trap cleanup_gnulib 1 2 13 15

    cvs -z3 -q -d ${CVS_PREFIX}cvs.savannah.gnu.org:/cvsroot/gnulib co gnulib ||
      cleanup_gnulib

    trap - 1 2 13 15
  fi
  GNULIB_SRCDIR=gnulib
esac

<$GNULIB_SRCDIR/gnulib-tool || exit
gnulib_tool="$GNULIB_SRCDIR/gnulib-tool --assume-autoconf=latest-stable"

gnulib_modules='
argmatch
dirname
error
extensions
fopen-safer
getopt
gettext
hash
malloc
mbswidth
obstack
quote
quotearg
stdbool
stdint
stpcpy
strerror
strtoul
strverscmp
unistd-safer
unlocked-io
verify
xalloc
xalloc-die
xstrndup
'

previous_gnulib_modules=
while [ "$gnulib_modules" != "$previous_gnulib_modules" ]; do
  previous_gnulib_modules=$gnulib_modules
  gnulib_modules=`
    (echo "$gnulib_modules"
     for gnulib_module in $gnulib_modules; do
       $gnulib_tool --extract-dependencies $gnulib_module
     done) | sort -u
  `
done

gnulib_files=`
  (echo m4/warning.m4
   for gnulib_module in $gnulib_modules; do
     $gnulib_tool --extract-filelist $gnulib_module
   done) | sort -u
`

gnulib_dirs=`echo "$gnulib_files" | sed 's,/[^/]*$,,' | sort -u`
mkdir -p $gnulib_dirs || exit

for gnulib_file in $gnulib_files; do
  dest=$gnulib_file
  rm -f $dest &&
  echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file" &&
  cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
done

# This suppresses a bogus diagnostic
# "warning: macro `AM_LANGINFO_CODESET' not found in library".
echo "$0: patching m4/gettext.m4 to remove need for intl/* ..."
sed '
  /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
    AC_DEFUN([AM_INTL_SUBDIR], [])
  /^AC_DEFUN(\[gt_INTL_SUBDIR_CORE],/,/^]/c\
    AC_DEFUN([gt_INTL_SUBDIR_CORE], [])
' m4/gettext.m4 >m4/gettext_gl.m4 || exit


# Get translations.

get_translations() {
  subdir=$1
  domain=$2

  echo "$0: getting translations into $subdir for $domain..."
  (cd $subdir && rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'`) &&

  $WGET_COMMAND -O "$subdir/$domain.html" "$TP_URL$domain" &&

  sed -n 's|.*"http://[^"]*/translation/teams/PO/\([^/"]*\)/'"$domain"'-\([^/"]*\)\.[^."]*\.po".*|\1.\2|p' <"$subdir/$domain.html" |
  sort -k 1,1 -k 2,2n -k2,2 -k3,3n -k3,3 -k4,4n -k4,4 -k5,5n -k5.5 |
  awk -F. '
    { if (lang && $1 != lang) print lang, ver }
    { lang = $1; ver = substr($0, index($0, ".") + 1) }
    END { if (lang) print lang, ver }
  ' | awk -v domain="$domain" -v subdir="$subdir" '
    {
      lang = $1

      # Work around bugs in Bison 2.3 translations uncovered by gettext 0.15.
      # This workaround can be removed once the translations are fixed.
      if (lang == "id" || lang == "ms" || lang == "tr") next

      ver = $2
      urlfmt = ""
      printf "$WGET_COMMAND -O %s/%s.po 'http://www.iro.umontreal.ca/translation/teams/PO/%s/%s-%s.%s.po' &&\n", subdir, lang, lang, domain, ver, lang
    }
    END { print ":" }
  ' | sh &&
  ls "$subdir"/*.po | sed 's|.*/||; s|\.po$||' >"$subdir/LINGUAS" &&
  rm "$subdir/$domain.html"
}

case $SKIP_PO in
'')
  case `wget --help` in
  *'--no-cache'*)
    no_cache='--no-cache';;
  *'--cache=on/off'*)
    no_cache='--cache=off';;
  *)
    no_cache='';;
  esac

  WGET_COMMAND="wget -nv $no_cache"
  export WGET_COMMAND

  get_translations po $package || exit

  case $package in
  bison)
    get_translations runtime-po $package-runtime || exit
  esac;;
esac


# Generate autoconf and automake snippets.

(echo '# This file is generated automatically by "bootstrap".' &&
 echo 'AC_DEFUN([GNULIB_AUTOCONF_SNIPPET],[' &&
 $gnulib_tool --extract-autoconf-snippet $gnulib_modules &&
 echo '])'
) >m4/gnulib.m4 || exit

(echo '# This file is generated automatically by "bootstrap".' &&
 $gnulib_tool --extract-automake-snippet $gnulib_modules |
 sed 's/^[	 ]*AM_CPPFLAGS[	 ]*+=/# (commented out by bootstrap) &/'
) >lib/gnulib.mk || exit


# Reconfigure, getting other files.

echo "$0: autopoint --force ..."
autopoint --force

# We don't need intl, so remove it.
intl_files_to_remove='
  intl
  m4/codeset.m4
  m4/gettext.m4
  m4/glibc2.m4
  m4/glibc21.m4
  m4/intdiv0.m4
  m4/intmax.m4
  m4/inttypes-h.m4
  m4/inttypes-pri.m4
  m4/lcmessage.m4
  m4/lock.m4
  m4/longdouble.m4
  m4/printf-posix.m4
  m4/signed.m4
  m4/size_max.m4
  m4/visibility.m4
  m4/wint_t.m4
  m4/xsize.m4
'
echo $0: rm -fr $intl_files_to_remove ...
rm -fr $intl_files_to_remove || exit


# Undo changes to gnulib files that autoreconf made.
for gnulib_file in $gnulib_files; do
  test ! -f $gnulib_file || cmp -s $gnulib_file $GNULIB_SRCDIR/$gnulib_file || {
    rm -f $gnulib_file &&
    echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file again" &&
    cp -p $GNULIB_SRCDIR/$gnulib_file $gnulib_file || exit
  }
done

# Make sure aclocal.m4 is not older than input files.
sleep 1

for command in \
  'aclocal --force -I m4' \
  'autoconf --force' \
  'autoheader --force' \
  'automake --add-missing --copy --force-missing';
do
  echo "$0: $command ..."
  $command || exit
done


# Put bug-reporting address into po/Makevars.
echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars

# Likewise for runtime-po/Makevars, except also change a few other parameters.
sed '
  s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
  s/^\(subdir\) *=.*/\1 = runtime-po/
  s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YY_/
' <po/Makevars >runtime-po/Makevars

# Copy identical files from po to runtime-po.
(cd po && cp -p Makefile.in.in *-quot *.header *.sed *.sin ../runtime-po)

# if src/parse-gram.[ch] are out of date, rebuild them.
parse_gram_y=`find src/parse-gram.y \
		 '(' -newer src/parse-gram.c -o -newer src/parse-gram.h ')' \
		 -print` || exit
case $parse_gram_y in
?*)
  echo "$0: warning: bootstrapping with old src/parse-gram.[ch] files."

  echo "$0: touch -c src/parse-gram.[ch] ... "
  touch -c src/parse-gram.[ch] || exit

  echo "$0: ./configure --disable-nls ..."
  ./configure --disable-nls || exit

  echo "$0: (cd lib && make) ..."
  (cd lib && make) || exit

  echo "$0: (cd src && make) ..."
  (cd src && make) || exit

  echo "$0: rm -f src/parse-gram.c src/parse-gram.h ..."
  rm -f src/parse-gram.c src/parse-gram.h || exit

  echo "$0: (cd src && make parse-gram.c parse-gram.h) ..."
  (cd src && make parse-gram.c parse-gram.h) || exit

  echo "$0: make distclean ..."
  make distclean || exit;;
esac

echo "$0: done.  Now you can run './configure'."